﻿using Calculator;
using System.Console;

module Program
{
  Main() : void
  {
    def calcParser = CalcParser();
    
    def calc(text : string) : void
    {

      try
      {
        match (calcParser.Parse(text))
        {
          | Some(result) => WriteLine(result);
          | None         => ()
        }
      }
      catch 
      { | e is ParserFatalError => 
          WriteLine(string(' ', e.Pos) +  "^");
          WriteLine(e.Message);
      }
    }
    
    def readInput()
    {
      def res = ReadLine();
      
      unless (res == "")
      {
        calc(res);
        readInput();
      }
    }
    
    readInput();
  }
}